/*
 * Pops the file name of the previous HTML page off a stack of all previously-viewed HTML pages
 */
function getPreviousURL() {
	var pageStack = getUrlVars()["prev"].split("^");
	var returnValue = pageStack.pop();
	returnValue = returnValue + ".html" + "?prev=" + pageStack.join("^");
	return returnValue;
}

/*
 * Adds the file name of the current HTML page to a stack of all previously-viewed HTML pages
 */
function getForwardURL(pageName) {
	if (getUrlVars()["prev"] != null) {
		var pageStack = getUrlVars()["prev"].split("^");
		pageStack.push(pageName);
		var returnValue = pageStack.join("^");
		return returnValue;
	}	else {
		return pageName;
	}
}

// Read a page's URL variables and return them as an associative array.
function getUrlVars(){
    var vars = [], hash;
    var hashes = window.location.href.slice(window.location.href.indexOf('?') + 1).split('&');
    for(var i = 0; i < hashes.length; i++)
    {
        hash = hashes[i].split('=');
        vars.push(hash[0]);
        vars[hash[0]] = hash[1];
    }
    return vars;
}

/*
 * Simulates clicking the "back" button
 */
function go_back(){
    var node = document.getElementById("backButton");   
    if (node != null){
        node.click();
    }        
}

/*
 * Simulates clicking the "continue" button
 */
function go_forward(){
    var node = document.getElementById("mainButton");   
    if (node == null && document.frames[0]){
        node = document.frames[0].document.getElementById("mainButton");  
        if (node != null){
            node.focus()
        }
    }
    if (node != null){
        node.click();   
    }
}

/*
 * Simulates clicking the "close" button
 */
function doClose() {
		if (self.macFinish){
				macFinish();
		}
		else{
			top.close();
		}
}

/*
 * Tells us whether or not we're running on IE5 (ouch)
 */
function isIE5(){
    var agent = window.navigator.userAgent;
    var msie = agent.indexOf("MSIE ");
    if (msie > 0){
        return (parseInt(agent.substring (msie+5, agent.indexOf (".", msie ))) == 5);
    }
    return false;
}

/*
 * Swallows the refresh key (F5) 
 */
function trapRefresh(e){
    switch(e.keyCode){
        case(37):         // Right arrow
          if (e.altKey){
            go_back();
          }
          break;
        case(39):         // Left arrow
          if (e.altKey){
            go_forward();
          }
          break;
        case(107):      // Plus  (broken)
        case(109):      // Minus (broken)
        case(116):      // F5
          e.keyCode = 0;
          break;
    }
}

/*
 * Forces title to be at most 2-lines
 */
function titleResize(){
   var node = document.getElementById("title");
   var content_node = document.getElementById("body-content"); //Added by Lankford on 2008/7/3.  The 'body-content' node is the parent node for all the content in the main area of each page.  This is consistent regardless of page type generated by the stylesheets.
   
   // Not sure these could ever be true.
   if (node == null){ return; }
   if (content_node == null){ return; } // Added by Lankford on 2008/6/25.

   // Consider this IE5 hack temporary.
   if (isIE5()){
        node.style.fontSize=30; 
        // Desperate throw for really long titles (excluding langs like Thai)
        if (node.outerText.length >= 145 && node.outerText.indexOf(' ') != -1){
        	var hack = document.getElementById("gcell");
        	if (hack != null){
        		hack.style.verticalAlign="top";
        	}
        }
        return;
   }
   
   var current = parseInt(node.style.fontSize);
   
   var height = node.offsetHeight;
   
   //var contentHeight = node.parentElement.parentElement.parentElement.offsetHeight;  //Removed by Lankford on 2008/6/25.
   contentHeight = content_node.offsetHeight; //Added by Lankford on 2008/6/25.

   if (contentHeight > 345){
        var diff = contentHeight - 345;
        resizeNode(node, height - diff);
        /*
        if (height > 48 && height < 96){
            resizeNode(node, 48);
        }
        else if (height > 96){
           resizeNode(node, 96);
        }
        else{
            node.parentNode.height = 48;
        }
    }
    else{
        if (height < 48){
            node.parentNode.height = 48;
        }
        else if (height > 96){
            resizeNode(node, 96);   
        } */
    } 
    else if (height > 96){ // guarantee 2 lines
        resizeNode(node, 96);
    }
    //resizeNode(node, 96);
}

function resizeNode(node, maxHeight){
    var current = parseInt(node.style.fontSize);
    while (node.offsetHeight > maxHeight+1){
        current -= 1;
        node.style.fontSize = current;
        //alert("Node offsetheight = " + node.offsetHeight + "|||Node.style.fontsize = " + node.style.fontSize + "|||maxHeight=" + maxHeight);
    }
    node.parentNode.height = maxHeight;
}